/** @file sdl_gui.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef SDL_GUI_CMDLINE_H
#define SDL_GUI_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef SDL_GUI_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define SDL_GUI_CMDLINE_PARSER_PACKAGE "para_sdl_gui"
#endif

#ifndef SDL_GUI_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define SDL_GUI_CMDLINE_PARSER_VERSION "0.2.17"
#endif

/** @brief Where the command line options are stored */
struct sdl_gui_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int fullscreen_flag;	/**< @brief Use fullscreeen mode (default=off).  */
  const char *fullscreen_help; /**< @brief Use fullscreeen mode help description.  */
  int interactive_flag;	/**< @brief Activate interactive mode (default=off).  */
  const char *interactive_help; /**< @brief Activate interactive mode help description.  */
  int width_arg;	/**< @brief Specify screen width (default='1024').  */
  char * width_orig;	/**< @brief Specify screen width original value given at command line.  */
  const char *width_help; /**< @brief Specify screen width help description.  */
  int height_arg;	/**< @brief Specify screen height (default='768').  */
  char * height_orig;	/**< @brief Specify screen height original value given at command line.  */
  const char *height_help; /**< @brief Specify screen height help description.  */
  char * config_file_arg;	/**< @brief (default='~/.paraslash/sdl_gui.conf').  */
  char * config_file_orig;	/**< @brief (default='~/.paraslash/sdl_gui.conf') original value given at command line.  */
  const char *config_file_help; /**< @brief (default='~/.paraslash/sdl_gui.conf') help description.  */
  char * window_id_arg;	/**< @brief (currently ignored).  */
  char * window_id_orig;	/**< @brief (currently ignored) original value given at command line.  */
  const char *window_id_help; /**< @brief (currently ignored) help description.  */
  char * stat_cmd_arg;	/**< @brief command to read server and audiod status data from (default='para_audioc stat').  */
  char * stat_cmd_orig;	/**< @brief command to read server and audiod status data from original value given at command line.  */
  const char *stat_cmd_help; /**< @brief command to read server and audiod status data from help description.  */
  char * pic_cmd_arg;	/**< @brief command to read pic from (default='para_client pic').  */
  char * pic_cmd_orig;	/**< @brief command to read pic from original value given at command line.  */
  const char *pic_cmd_help; /**< @brief command to read pic from help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int fullscreen_given ;	/**< @brief Whether fullscreen was given.  */
  int interactive_given ;	/**< @brief Whether interactive was given.  */
  int width_given ;	/**< @brief Whether width was given.  */
  int height_given ;	/**< @brief Whether height was given.  */
  int config_file_given ;	/**< @brief Whether config_file was given.  */
  int window_id_given ;	/**< @brief Whether window-id was given.  */
  int stat_cmd_given ;	/**< @brief Whether stat_cmd was given.  */
  int pic_cmd_given ;	/**< @brief Whether pic_cmd was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct sdl_gui_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure sdl_gui_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure sdl_gui_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *sdl_gui_args_info_purpose;
/** @brief the usage string of the program */
extern const char *sdl_gui_args_info_usage;
/** @brief all the lines making the help output */
extern const char *sdl_gui_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int sdl_gui_cmdline_parser (int argc, char * const *argv,
  struct sdl_gui_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use sdl_gui_cmdline_parser_ext() instead
 */
int sdl_gui_cmdline_parser2 (int argc, char * const *argv,
  struct sdl_gui_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int sdl_gui_cmdline_parser_ext (int argc, char * const *argv,
  struct sdl_gui_args_info *args_info,
  struct sdl_gui_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int sdl_gui_cmdline_parser_file_save(const char *filename,
  struct sdl_gui_args_info *args_info);

/**
 * Print the help
 */
void sdl_gui_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void sdl_gui_cmdline_parser_print_version(void);

/**
 * Allocates dynamically a sdl_gui_cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized sdl_gui_cmdline_parser_params structure
 */
struct sdl_gui_cmdline_parser_params *sdl_gui_cmdline_parser_params_init(void);

/**
 * Initializes the passed sdl_gui_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void sdl_gui_cmdline_parser_init (struct sdl_gui_args_info *args_info);
/**
 * Deallocates the string fields of the sdl_gui_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void sdl_gui_cmdline_parser_free (struct sdl_gui_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use sdl_gui_cmdline_parser_config_file() instead
 */
int sdl_gui_cmdline_parser_configfile (char * const filename,
  struct sdl_gui_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int sdl_gui_cmdline_parser_config_file (char * const filename,
  struct sdl_gui_args_info *args_info,
  struct sdl_gui_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int sdl_gui_cmdline_parser_required (struct sdl_gui_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SDL_GUI_CMDLINE_H */
